/*************************************************************************
 * $Id: MyMessage.cpp,v 1.7 2006/03/16 17:49:18 vtolkatc Exp $
 *
 * This file is a part of the "Common" project which implements all the 
 * common classes shared by the client and service samples.
 *
 *
 * Copyright (c) 2001-2006 Platform Computing Corporation. 
 * Accelerating Intelligence(TM). All rights reserved.
 *
 * This exposed source code is the confidential and proprietary property
 * of Platform Computing Corporation. Your right to use is strictly limited
 * by the terms of the license agreement entered into with Platform Computing
 * Corporation.
 *
 *************************************************************************/

#include "stdafx.h"
#include <string.h>
#include "MyMessage.h"
#include "soam.h"

using namespace soam;

MyMessage::MyMessage()
{
    m_int = 0;
    m_string = copyString("");
}

MyMessage::MyMessage(int i, bool isSync, char* str)
{
    m_int = i;
    m_isSync = isSync;
    m_string = copyString(str);
}

MyMessage::~MyMessage(void)
{
    freeString(m_string);
}

void MyMessage::onSerialize(OutputStreamPtr &stream) throw (SoamException)
{
    stream->write(m_int);
    stream->write(m_isSync);
    stream->write(m_string);
}

void MyMessage::onDeserialize(InputStreamPtr &stream) throw (SoamException)
{
    stream->read(m_int);
    stream->read(m_isSync);

    // we now own the string that was read
    stream->read(m_string);
}

char* MyMessage::copyString(const char* strSource)
{
    SOAM_ASSERT(SOAM_NULL_PTR != strSource);

    size_t len = strlen(strSource);
    char* newString = new char[len+1];
    
    SOAM_ASSERT(SOAM_NULL_PTR != newString);
    strcpy(newString, strSource);

    return newString;
}

void MyMessage::freeString(char* strToFree)
{
    if (SOAM_NULL_PTR != strToFree) {
	delete []strToFree;
    }
}

