/*************************************************************************
 * $Id: MyMessage.h,v 1.5 2006/03/16 17:49:18 vtolkatc Exp $
 *
 * This file is a part of the "Common" project which implements all the 
 * common classes shared by the client and service samples.
 *
 *
 * Copyright (c) 2001-2006 Platform Computing Corporation. 
 * Accelerating Intelligence(TM). All rights reserved.
 *
 * This exposed source code is the confidential and proprietary property
 * of Platform Computing Corporation. Your right to use is strictly limited
 * by the terms of the license agreement entered into with Platform Computing
 * Corporation.
 *
 *************************************************************************/

#pragma once
#include "soam.h"


class MyMessage : 
public soam::Message
{
  public:
    MyMessage();
    MyMessage(int i, bool isSync, char* str);
    virtual ~MyMessage(void);

    void onSerialize(
        /*[in]*/ soam::OutputStreamPtr &stream) throw (soam::SoamException); 

    void onDeserialize(
	/*[in]*/ soam::InputStreamPtr &stream) throw (soam::SoamException); 

// accessors
  public:
    int getInt() {return m_int;}
    void setInt(int _int) {m_int = _int;}
    const char* getString() {return m_string;}
    void setString(const char* str) {freeString(m_string); m_string = copyString(str);}
    bool getIsSync() {return (m_isSync != 0);}
    void setIsSync(bool isSync) {m_isSync = isSync;}
    
  private:
    char* copyString(const char* strSource);
    void freeString(char* strToFree);
    
  private:
    int m_int;
    bool m_isSync;
    char* m_string;
};
